<?php
//  $Id: image_drawing.inc,v 1.5 2008/06/13 15:01:25 tistur Exp $
include(drupal_get_path('module', 'image_overlay') .'/drawing_shapes.inc');

/**
 * image_overlay_drawing_split_points
 * Takes an array of point pairs and returns an array of points. ints & floats ok.
 * { {x1, y1}, {x2, y2}, {x3, y3}, {x4, y4} } to 
 * { x1, y1, x2, y2, x3, y3, x4,y4 }
 * 
 * Converts any invalid number into a zero
 */
function image_overlay_drawing_split_points( $arr, $num ) {
  $ans = array();
  $string = '';
  for ($i = 0, $j = 0; $i < count($arr); $i++ ) {
    $t = $arr[$i];
    $ans[$j++] = $t[0];
    $ans[$j++] = $t[1];
  }
  return $ans;
}


/**
 * image_overlay_drawing_parse_color
 *
 * @param $im  the image to allocate the color to
 * @param $color a string in the form "rgb(255, 255, 255)" or "#FFFFFF" or "FFFFFF"
 * @return the color allocated using imagecolorallocate. If color cannot be read, allocates black
 */
function image_overlay_drawing_parse_color(&$im, $color) {
  $ans = NULL;
  $numbers = array();
  ////dpr($color);
  if (substr_count($color, "rgb")) {
    $numbers = preg_split("/[rgb,[)(\]]+/", $color, -1, PREG_SPLIT_NO_EMPTY);
  }
  else {
    $arr = array();
    preg_match_all("/([0-9a-fA-F][0-9a-fA-F])([0-9a-fA-F][0-9a-fA-F])([0-9a-fA-F][0-9a-fA-F])/", $color, $arr);
    $count = count($arr);
    for ($i=1; $i<$count;$i++) {
      $numbers[$i-1] = hexdec($arr[$i][0]);
    }
  }
  
  if (count($numbers) < 1) {
    $numbers[0] = 0;
    $numbers[1] = 0;
    $numbers[2] = 0;
  }
  return imagecolorallocate($im, $numbers[0], $numbers[1], $numbers[2]);
}


/**
 * image_overlay_drawing_create_image
 * Actually makes the image
 */
function image_overlay_drawing_create_image($extension, $image_base) {
	if ( ! is_file($image_base) ) {
		watchdog("noimage", "$image_base  is not a file");
	}

  watchdog('image',"$image_base  Is the image_base");
  if ( (! strcmp($extension, "jpg")) || (!strcmp($extension, "jpeg"))) {
    return imagecreatefromjpeg($image_base);
  }
  if (! strcmp($extension, "png")) {
    return imagecreatefrompng($image_base);
    }
    if (! strcmp($extension, "gif")) {
    return imagecreatefromgif($image_base);
  }
  
  /*      $imagefunction = 'imagecreatefrom' . $bgimagetype;
      $im = $imagefunction($backgroundimage);
*/
}

function image_overlay_drawing_save_image(&$im, $new_name, $extension) {
    $imagefunction = "image$extension";
    $imagefunction($im, $new_name);
    watchdog('file creation : ', "Name is $new_name, created by $imagefunction");
}

function image_overlay_drawing_cleanup_image(&$im) {
  imagedestroy($im);
}

function _image_overlay_shape_string($obj) {
}

function _image_overlay_make_image( $coords, $file, $extension, $original_nid ) {
//  dpr($file);
	watchdog("image", $file);
  $info = json_decode($coords);
  $canvases =  $info->image_with_drawings->drawings;

  $first_slash = strrpos($file, '/');
  $last_dot = strrpos($file, '.');
  $length = $last_dot - $first_slash - 1;

  $new_file['name'] = 'output';
  //$new_file['name'] = substr($file, $first_slash+1, $length) . '_overlay';
  
  
  $new_file['dir'] = drupal_get_path('module','image_overlay').'/../../files/temp/';
  $new_file['type'] = strtolower($extension);
  
  if (!strcmp($new_file['type'], "jpeg")) {
    $new_file['type'] = 'jpg';
  }
	if ( !strcmp($new_file['type'], "gif")){
		$new_file['type'] = 'png';
  }

	//  watchdog('new overlay called', "name : {$new_file['name']}, dir: {$new_file['dir']}, type : {$new_file['type']}  or if you prefer the original $file, ");

  $new_name =  $new_file['dir'] . $new_file['name'] .'.'. $new_file['type'];

  
  $im = image_overlay_drawing_create_image($extension, $file);
  
  for ($i = 0; $i < count($canvases); $i++) {
    image_overlay_drawing_shape($im, $canvases[$i]->Shape);
//    $new_file['shapes'][] = json_encode($canvases[$i]->Shape);
//    $new_file['shapes'][] .= _image_overlay_shape_string($canvases[$i]->Arrow);
  }
  
  image_overlay_drawing_save_image($im, $new_name, $new_file['type']);
  image_overlay_drawing_cleanup_image($im);

  return $new_file;
}



//_image_overlay_read_shape( )

/*
function _image_overlay_get_num( ) {
  $ans = variable_get('image_overlay_count', 0);
  if ( $ans > 100 ) {
    variable_set('image_overlay_count', 1);
  }
  return $ans;
}

function _image_overlay_find_int( $a1 ) {
  static $pattern = "/[\-]?[0-9]*{\.}?[0-9]/";
  $result = preg_match_all($pattern, $a1);
  if ( !$result ) {
    return 0;
  }
  return to_float($a1);
}*/
  