

function Point( int_x, int_y ) {
	this.x;
	this.y;
	this.Set(int_x, int_y);
}
Point.prototype.GetX = function() { return this.x; }
Point.prototype.GetY = function() { return this.y; }
Point.prototype.Set = function( int_x, int_y) {
	this.x = int_x;
	this.y = int_y;
};
Point.prototype.toPrintableString = function() {
	ans = '('  + this.GetX() + ',' + this.GetY() + ')';
	return ans;
};
Point.prototype.Add = function( other_point, blank_point ) {
	var newX = this.GetX() + other_point.GetX();
	var newY = this.GetY() + other_point.GetY();
	blank_point.Set(newX, newY);
	return;
};
Point.prototype.toJSON = function () {
	return [
		this.GetX(), 
		this.GetY() 
	];
};


function Rect() {
	this.TopLeft  = new Point();
	this.TopRight = new Point();
	this.BottomLeft = new Point();
	this.BottomRight = new Point();
}
Rect.prototype.SetPoints = function(left_x, right_x, upper_y, lower_y) {
left_x = parseInt(left_x);
right_x = parseInt(right_x);
upper_y = parseInt(upper_y);
lower_y = parseInt(lower_y);
	this.TopLeft.Set(left_x, upper_y);
	this.TopRight.Set(right_x, upper_y);
	this.BottomLeft.Set(left_x, lower_y);
	this.BottomRight.Set(right_x, lower_y);
};
Rect.prototype.GetLeftX = function() { return this.TopLeft.GetX(); };
Rect.prototype.GetRightX = function() { return this.TopRight.GetX(); };
Rect.prototype.GetTopY = function() { return this.TopLeft.GetY(); };
Rect.prototype.GetBottomY = function() { return this.BottomLeft.GetY(); };
Rect.prototype.toPrintableString = function( ) {
	var ans = "[" + 	this.TopLeft.toPrintableString() + this.BottomRight.toPrintableString() + "]";
	return ans;
};
Rect.prototype.GetWidth = function() { return this.GetRightX() - this.GetLeftX(); };
Rect.prototype.GetHeight = function() { return this.GetBottomY() - this.GetTopY(); };
Rect.prototype.GetArea = function() { return this.GetHeight() * this.GetWidth(); };
Rect.prototype.GetPoint = function ( int_which ) { //1 = upperleft, 2 = upper right, 3 = lower left, 4 = lower right
	var ans = 0;
	switch ( int_which ) {
		case 1:
			ans = this.TopLeft;
			break;
		case 2:
			ans = this.TopRight;
			break;
		case 3:
			ans = this.BottomLeft;
			break;
		case 4:
			ans = this.BottomRight;
			break;	
	}
		return ans;
};
Rect.prototype.Draw = function(color,id) { 
  var canvas = document.getElementById(id);
  // Make sure we don't execute when canvas isn't supported
  if (canvas.getContext) {
    // use getContext to use the canvas for drawing
    var ctx = canvas.getContext('2d');
				ctx.fillStyle = color;
				ctx.lineWidth = 1;

    // Filled triangle
    ctx.fillRect(this.GetLeftX(), this.GetTopY(), this.GetWidth(), this.GetHeight());
	}
//fillRect(x,y,width,height) : Draws a filled rectangle
};
Rect.prototype.toJSON = function( add_point, bool_wrapper ) { 
	var newUpperLeft = new Point( 0, 0 );
	var newLowerRight = new Point( 0, 0 );
	
	this.TopLeft.Add(add_point, newUpperLeft);
	this.BottomRight.Add(add_point, newLowerRight);
		var points = [ 
			newUpperLeft.toJSON(), 
			newLowerRight.toJSON() 
		]	
	if (bool_wrapper){
		return { 
			"rectangle" : points
		};
	} else {
		return points;
	}
};


function Arrow(int_left_x, int_right_x, int_upper_y, int_lower_y, div_id, canvas_id, color) {
	this.outerBox = new Rect();
	this.outerArea = new Rect();
	this.rectanglePart = new Rect();
	this.trianglePart = new Triangle();
	this.SetOuterLimits(int_left_x, int_right_x, int_upper_y, int_lower_y);
	//this.SetArea(0, int_right_x - int_left_x, 0, int_lower_y - int_upper_y);
	
	this.id = canvas_id;
	this.container_id = div_id;
	
	if ( color ) {
		this.SetColor(color);
	};
	
//	this.
}
Arrow.prototype.ChangeMe = function() {

	var canvas = $("#"+this.id);
	var container = $("#"+this.container_id);
	
	var top = parseInt(container.css("top"));
	var left = parseInt(container.css("left"));
	var height = parseInt(container.css("height"));
	var width =  parseInt(container.css("width"));

	canvas.css("top", top);
	canvas.css("left", left);
	canvas.css("height", height);
	canvas.css("width", width);

	canvas.attr("height", height);
	canvas.attr("width",width);

	this.SetOuterLimits(left, left+width, top, top+height);
	this.Draw();
};
Arrow.prototype.GetBottomSpace = function() { return 5; };
Arrow.prototype.GetTopSpace = function() { return 5; };
Arrow.prototype.GetSideRectSpace = function() { return 20; };
Arrow.prototype.GetRectangleHeightFraction = function() { return (7/10); };
Arrow.prototype.SetOuterLimits = function ( left, right, upper, lower ) {
	var old_height = this.outerBox.GetHeight();
	var old_width = this.outerBox.GetWidth();
	var diff = false;
	
	this.outerBox.SetPoints(left, right, upper, lower);
	
	if ( (old_height != this.outerBox.GetHeight()) || (old_width != this.outerBox.GetWidth()) ) { 
		this.SetArea(0, right - left, 0, lower - upper);
		diff = true;
	}
	return diff;
};
Arrow.prototype.SetArea = function (int_left_x, int_right_x, int_upper_y, int_lower_y) {
	this.outerArea.SetPoints(int_left_x, int_right_x, int_upper_y, int_lower_y);
	this.CalculateRect();
	this.CalculateTriangle();
};
Arrow.prototype.GetOuterSize = function() { return this.outerArea.GetArea(); };
Arrow.prototype.GetRectSize = function() { return this.rectanglePart.GetArea(); };
Arrow.prototype.CalculateRect = function() {
	var height = this.outerArea.GetHeight() - this.GetTopSpace();
	height *= this.GetRectangleHeightFraction();
	if ( height < 0 ) { height *= (-1); }
	
	var y_top = this.GetTopSpace() - this.outerArea.GetTopY();
	if( y_top < 0 ) { y_top *= (-1);};
	var y_bottom = y_top + height;
	var x_left = this.outerArea.GetLeftX() + this.GetSideRectSpace();
	var x_right = this.outerArea.GetRightX() - this.GetSideRectSpace();
	
	this.rectanglePart.SetPoints(x_left, x_right, y_top, y_bottom);
};
Arrow.prototype.CalculateTriangle = function() {

	var height = this.outerArea.GetHeight() - this.rectanglePart.GetHeight() - this.GetBottomSpace();
	var tip_y = this.rectanglePart.GetBottomY() + height;
	var tip_x = this.outerArea.GetLeftX() + ( this.outerArea.GetWidth() / 2 );
	
	var top_inset = this.GetRectangleHeightFraction() / 2 ;
	
	var left = this.outerArea.GetLeftX() + top_inset;
	var right = this.outerArea.GetRightX() - top_inset;
	
	this.trianglePart.SetPoint(0, left, this.rectanglePart.GetBottomY());
	this.trianglePart.SetPoint(1, right, this.rectanglePart.GetBottomY());
	this.trianglePart.SetPoint(2, tip_x, tip_y);	
};
Arrow.prototype.SetColor = function(new_color) { this.color = new_color; };
Arrow.prototype.GetColor = function() { return this.color; };
Arrow.prototype.Draw = function() {
	this.rectanglePart.Draw(this.color, this.id);
	this.trianglePart.Draw(this.color, this.id);
};
Arrow.prototype.toPrintableString = function() {
	var ans = this.GetColor() + '*';
	var tri = this.trianglePart.GetPoints();
	var i;
	
	var starter = this.outerBox.GetPoint(1);
	var rectUpperLeft = new Point();
	starter.Add( this.rectanglePart.GetPoint(1), rectUpperLeft);
	
	var rectLowerRight = new Point();
	starter.Add( this.rectanglePart.GetPoint(4), rectLowerRight);
	var y='';
	for(i = 0; i < tri.length; i++) {
		y += tri[i].Add(starter, tri[i]);
	};
	
	ans += '['; // the rectangle
	ans += rectUpperLeft.toPrintableString() + rectLowerRight.toPrintableString();
	ans += ']';
	
	ans += '*';
	var l = '';
	ans += '[';
	for(i = 0; i < tri.length; i++) {
		l += tri[i].toPrintableString();
	};
	ans += l + ']';
	var jsontri = new Array();
	for (i = 0; i < tri.length; i++){
		jsontri[i] = tri[i].toJSON();		
	};
	
	return ans;
};
Arrow.prototype.toJSON = function() {
	var tri = this.trianglePart.GetPoints();
	var jsontri = new Array();
	var i;
	var starter = this.outerBox.GetPoint(1);
	
	for(i = 0; i < tri.length; i++) {
		tri[i].Add(starter, tri[i]);
		jsontri[i] = tri[i].toJSON();		
	}
	
	var ans = { 
		"Arrow" : {
			"color" : this.GetColor(),
			"rectangle" : this.rectanglePart.toJSON(starter, false),
			"polygon" : jsontri
		}
	};
	return ans;
};
Arrow.prototype.Rotate = function( num ) {
	var canvas = document.getElementById(this.id);
	var rad = standardDegreesToRadians( num );
	// Make sure we don't execute when canvas isn't supported
	if (canvas.getContext) {
		var ctx = canvas.getContext('2d');
		ctx.save();
		ctx.rotate(rad);
		this.CalculateRect();
		this.CalculateTriangle();
		//var top_x = (this.rectanglePart
//		ctx.restore();
	}
};

standardDegreesToRadians = function ( num_degrees ) {
	switch ( num_degrees ) {
		case 0:
			return 0;
		case 45:
			return Math.PI / 4;
		case 90:
			return Math.PI / 2;
		case 135:
			return (3 * Math.PI)/ 4;
		case 180:
			return Math.PI;
		case 225:	
			return (5 * Math.PI)/ 4;
		case 270:
			return (3 * Math.PI)/ 2;
		case 315:
			return (7 * Math.PI)/ 4;
		case 360:
			return 2 * Math.PI;
		default:
			return 0;
	}

}

function max ( a, b ) {
	if ( a > b ) {
		return a;
	} else {
		return b;
	}
}

function Circle(int_left_x, int_right_x, int_upper_y, int_lower_y, div_id, canvas_id, color) {
	this.outerBox = new Rect();
	this.outerArea = new Rect();
	this.rectanglePart = new Rect();
	this.trianglePart = new Triangle();
	this.SetOuterLimits(int_left_x, int_right_x, int_upper_y, int_lower_y);
	//this.SetArea(0, int_right_x - int_left_x, 0, int_lower_y - int_upper_y);
	
	this.id = canvas_id;
	this.container_id = div_id;
	
	if ( color ) {
		this.SetColor(color);
	};
	

	Circle.prototype.SetColor = function(new_color) { this.color = new_color; };
}
/*Ellipse.prototype.Draw = function () {
  var canvas = document.getElementById(this.id);
  if (canvas.getContext){
    var ctx = canvas.getContext('2d');
		ctx.lineWidth(this.lineWidth);
		ctx.arc(this.center.GettX(), this.center.GetY(), this.radius, 0, ( Math.PI * 2 ), true);
		ctx.stroke();
  }
};*/






function Triangle(arr_points) {
	this.points = new Array();
	this.points[0] = new Point();
	this.points[1] = new Point();
	this.points[2] = new Point();
	
}
Triangle.prototype.SetPoint = function( int_point_num, int_x, int_y ) {
	this.points[int_point_num].Set(int_x, int_y);
};
Triangle.prototype.Draw = function( color, id ) {
  var canvas = document.getElementById(id);
  
  if (canvas.getContext) {						// Make sure we don't execute when canvas isn't supported
    var ctx = canvas.getContext('2d');
		ctx.lineWidth = 1;
    // Filled triangle
    ctx.beginPath();
    ctx.moveTo(this.points[0].GetX(), this.points[0].GetY());
		var i = 0;
		for ( i = 1; i < 3; i++ ) {
			ctx.lineTo(this.points[i].GetX(), this.points[i].GetY());
		};
		ctx.closePath();
		ctx.fillStyle = color;
    ctx.fill();
  }
};
Triangle.prototype.toPrintableString = function( ) {
	ans = "[";
	var i;
	for ( i = 0; i < 3; i++ ) {
		ans += this.points[i].toPrintableString();
	}
	ans += "]";
	return ans; 
 };
Triangle.prototype.GetPoints = function() {
	return this.points;
};


function RemovePX(str) {
	var where = str.indexOf("px");
	ans = str.substring(0,where);
	ans *= 1;
	return ans;
};